<?php namespace App\Controllers\Tarifas;


use App\Controllers\BaseResourceController;

use App\Models\Collection;

use App\Entities\Tarifas\TarifaManipuladoLinea;

use App\Models\Tarifas\TarifaManipuladoLineaModel;

use
    DataTables\Editor,
    DataTables\Database,
    DataTables\Editor\Field,
    DataTables\Editor\Format,
    DataTables\Editor\Mjoin,
    DataTables\Editor\Options,
    DataTables\Editor\Upload,
    DataTables\Editor\Validate,
    DataTables\Editor\ValidateOptions;


class Tarifamanipuladolineas extends \App\Controllers\BaseResourceController
{

    protected $modelName = TarifaManipuladoLineaModel::class;
    protected $format = 'json';

    protected static $singularObjectName = 'Tarifa Manipulado Linea';
    protected static $singularObjectNameCc = 'tarifaManipuladoLinea';
    protected static $pluralObjectName = 'Tarifa Manipulado Lineas';
    protected static $pluralObjectNameCc = 'tarifaManipuladoLineas';

    protected static $controllerSlug = 'tarifamanipuladolineas';

    protected static $viewPath = 'themes/vuexy/form/tarifas/manipulado/';

    protected $indexRoute = 'tarifaManipuladoLineaList';


    public function initController(\CodeIgniter\HTTP\RequestInterface $request, \CodeIgniter\HTTP\ResponseInterface $response, \Psr\Log\LoggerInterface $logger)
    {
        $this->viewData['pageTitle'] = lang('TarifaManipuladoLineas.moduleTitle');
        $this->viewData['usingSweetAlert'] = true;

        // Se indica que este controlador trabaja con soft_delete
        $this->soft_delete = true;
        // Se indica el flag para los ficheros borrados
        $this->delete_flag = 1;

        parent::initController($request, $response, $logger);
    }


    public function index()
    {

        $viewData = [
            'currentModule' => static::$controllerSlug,
            'pageSubTitle' => lang('Basic.global.ManageAllRecords', [lang('TarifaManipuladoLineas.tarifamanipuladoLinea')]),
            'tarifaManipuladoLinea' => new TarifaManipuladoLinea(),
            'usingServerSideDataTable' => true,

        ];

        $viewData = array_merge($this->viewData, $viewData); // merge any possible values from the parent controller class

        return view(static::$viewPath . 'viewTarifaManipuladoLineaList', $viewData);
    }


    public function add()
    {


        

        if ($this->request->getPost()) :

            $nullIfEmpty = true; // !(phpversion() >= '8.1');

            $postData = $this->request->getPost();

            $sanitizedData = $this->sanitized($postData, $nullIfEmpty);


            $noException = true;
            if ($successfulResult = $this->canValidate()) : // if ($successfulResult = $this->validate($this->formValidationRules) ) :


                if ($this->canValidate()) :
                    try {
                        $successfulResult = $this->model->skipValidation(true)->save($sanitizedData);
                    } catch (\Exception $e) {
                        $noException = false;
                        $this->dealWithException($e);
                    }
                else:
                    $this->viewData['errorMessage'] = lang('Basic.global.formErr1', [lang('Basic.global.record')]);
                    $this->session->setFlashdata('formErrors', $this->model->errors());
                endif;

                $thenRedirect = true;  // Change this to false if you want your user to stay on the form after submission
            endif;
            if ($noException && $successfulResult) :

                $id = $this->model->db->insertID();

                $message = lang('Basic.global.saveSuccess', [lang('Basic.global.record')]) . '.';

                if ($thenRedirect) :
                    if (!empty($this->indexRoute)) :
                        return redirect()->to(route_to($this->indexRoute))->with('sweet-success', $message);
                    else:
                        return $this->redirect2listView('sweet-success', $message);
                    endif;
                else:
                    $this->session->setFlashData('sweet-success', $message);
                endif;

            endif; // $noException && $successfulResult

        endif; // ($requestMethod === 'post')

        $this->viewData['tarifaManipuladoLinea'] = isset($sanitizedData) ? new TarifaManipuladoLinea($sanitizedData) : new TarifaManipuladoLinea();

        $this->viewData['formAction'] = route_to('createTarifaManipuladoLinea');

        $this->viewData['boxTitle'] = lang('Basic.global.addNew') . ' ' . lang('TarifaManipuladoLineas.moduleTitle') . ' ' . lang('Basic.global.addNewSuffix');


        return $this->displayForm(__METHOD__);
    } // end function add()

    public function edit($requestedId = null)
    {

        if ($requestedId == null) :
            return $this->redirect2listView();
        endif;
        $id = filter_var($requestedId, FILTER_SANITIZE_URL);
        $tarifaManipuladoLinea = $this->model->find($id);

        if ($tarifaManipuladoLinea == false) :
            $message = lang('Basic.global.notFoundWithIdErr', [mb_strtolower(lang('TarifaManipuladoLineas.tarifamanipuladoLinea')), $id]);
            return $this->redirect2listView('sweet-error', $message);
        endif;

        

        if ($this->request->getPost()) :

            $nullIfEmpty = true; // !(phpversion() >= '8.1');

            $postData = $this->request->getPost();

            $sanitizedData = $this->sanitized($postData, $nullIfEmpty);


            $noException = true;
            if ($successfulResult = $this->canValidate()) : // if ($successfulResult = $this->validate($this->formValidationRules) ) :


                if ($this->canValidate()) :
                    try {
                        $successfulResult = $this->model->skipValidation(true)->update($id, $sanitizedData);
                    } catch (\Exception $e) {
                        $noException = false;
                        $this->dealWithException($e);
                    }
                else:
                    $this->viewData['warningMessage'] = lang('Basic.global.formErr1', [mb_strtolower(lang('TarifaManipuladoLineas.tarifamanipuladoLinea'))]);
                    $this->session->setFlashdata('formErrors', $this->model->errors());

                endif;

                $tarifaManipuladoLinea->fill($sanitizedData);

                $thenRedirect = false;
            endif;
            if ($noException && $successfulResult) :
                $id = $tarifaManipuladoLinea->id ?? $id;
                $message = lang('Basic.global.updateSuccess', [lang('Basic.global.record')]) . '.';

                if ($thenRedirect) :
                    if (!empty($this->indexRoute)) :
                        return redirect()->to(route_to($this->indexRoute))->with('sweet-success', $message);
                    else:
                        return $this->redirect2listView('sweet-success', $message);
                    endif;
                else:
                    $this->session->setFlashData('sweet-success', $message);
                endif;

            endif; // $noException && $successfulResult
        endif; // ($requestMethod === 'post')

        $this->viewData['tarifaManipuladoLinea'] = $tarifaManipuladoLinea;

        $this->viewData['formAction'] = route_to('updateTarifaManipuladoLinea', $id);

        $this->viewData['boxTitle'] = lang('Basic.global.edit2') . ' ' . lang('TarifaManipuladoLineas.moduleTitle') . ' ' . lang('Basic.global.edit3');


        return $this->displayForm(__METHOD__, $id);
    } // end function edit(...)


    public function datatable_editor()
    {
        if ($this->request->isAJAX()) {

            include(APPPATH . "ThirdParty/DatatablesEditor/DataTables.php");

            // Build our Editor instance and process the data coming from _POST
            $response = Editor::inst($db, 'tarifa_manipulado_lineas')
                ->fields(
                    Field::inst('tirada_min')
                        ->getFormatter( 'Format::toDecimalChar')->setFormatter( 'Format::fromDecimalChar')
                        ->validator('Validate::numeric', array(
                                "decimal" => ',',
                                'message' => lang('TarifaAcabadoLineas.validation.tirada_min.decimal'))
                        )
                        ->validator('Validate::notEmpty', array(
                                'message' => lang('TarifaAcabadoLineas.validation.tirada_min.required'))
                        ),
                    Field::inst('tirada_max')
                        ->getFormatter( 'Format::toDecimalChar')->setFormatter( 'Format::fromDecimalChar')
                        ->validator('Validate::numeric', array(
                                "decimal" => ',',
                                'message' => lang('TarifaAcabadoLineas.validation.tirada_max.decimal'))
                        )
                        ->validator('Validate::notEmpty', array(
                                'message' => lang('TarifaAcabadoLineas.validation.tirada_max.required'))
                        ),
                    Field::inst('precio_min')
                        ->getFormatter( 'Format::toDecimalChar')->setFormatter( 'Format::fromDecimalChar')
                        ->validator('Validate::numeric', array(
                                "decimal" => ',',
                                'message' => lang('TarifaAcabadoLineas.validation.precio_min.decimal'))
                        )
                        ->validator('Validate::notEmpty', array(
                                'message' => lang('TarifaAcabadoLineas.validation.precio_min.required'))
                        ),
                    Field::inst('precio_max')
                        ->getFormatter( 'Format::toDecimalChar')->setFormatter( 'Format::fromDecimalChar')
                        ->validator('Validate::numeric', array(
                                "decimal" => ',',
                                'message' => lang('TarifaAcabadoLineas.validation.precio_max.decimal'))
                        )
                        ->validator('Validate::notEmpty', array(
                                'message' => lang('TarifaAcabadoLineas.validation.precio_max.required'))
                        ),
                    Field::inst('margen')
                        ->getFormatter( 'Format::toDecimalChar')->setFormatter( 'Format::fromDecimalChar')
                        ->validator('Validate::numeric', array(
                                "decimal" => ',',
                                'message' => lang('TarifaAcabadoLineas.validation.margen.decimal'))
                        )
                        ->validator('Validate::notEmpty', array(
                                'message' => lang('TarifaAcabadoLineas.validation.margen.required'))
                        ),
                    Field::inst('tarifa_manipulado_id'),
                    Field::inst('user_created_id'),
                    Field::inst('created_at'),
                    Field::inst('user_updated_id'),
                    Field::inst('updated_at'),
                    Field::inst('is_deleted'),
                    Field::inst('deleted_at'),

                )
                ->validator(function ($editor, $action, $data) {
                    if ($action === Editor::ACTION_CREATE || $action === Editor::ACTION_EDIT) {
                        foreach ($data['data'] as $pkey => $values) {
                            // Si no se quiere borrar...
                            if ($data['data'][$pkey]['is_deleted'] != 1) {
                                $process_data['tirada_min'] = $data['data'][$pkey]['tirada_min'];
                                $process_data['tirada_max'] = $data['data'][$pkey]['tirada_max'];
                                $response = $this->model->checkIntervals($process_data, $pkey, $data['data'][$pkey]['tarifa_manipulado_id']);
                                // No se pueden duplicar valores al crear o al editar
                                if (!empty($response)) {
                                    return $response;
                                }
                            }
                        }
                    }
                })
                ->on('preCreate', function ($editor, &$values) {
                    $session = session();
                    $datetime = (new \CodeIgniter\I18n\Time("now"));
                    $editor
                        ->field('user_created_id')
                        ->setValue($session->id_user);
                    $editor
                        ->field('created_at')
                        ->setValue($datetime->format('Y-m-d H:i:s'));
                })
                ->on('preEdit', function ($editor, &$values) {
                    $session = session();
                    $datetime = (new \CodeIgniter\I18n\Time("now"));
                    $editor
                        ->field('user_updated_id')
                        ->setValue($session->id_user);
                    $editor
                        ->field('updated_at')
                        ->setValue($datetime->format('Y-m-d H:i:s'));
                })
                ->debug(true)
                ->process($_POST)
                ->data();

            $newTokenHash = csrf_hash();
            $csrfTokenName = csrf_token();

            $response[$csrfTokenName] = $newTokenHash;

            echo json_encode($response);

        } else {
            return $this->failUnauthorized('Invalid request', 403);
        }
    }

    public function datatable()
    {
        if ($this->request->isAJAX()) {
            $reqData = $this->request->getPost();
            if (!isset($reqData['draw']) || !isset($reqData['columns'])) {
                $errstr = 'No data available in response to this specific request.';
                $response = $this->respond(Collection::datatable([], 0, 0, $errstr), 400, $errstr);
                return $response;
            }
            $start = $reqData['start'] ?? 0;
            $length = $reqData['length'] ?? 5;
            $search = $reqData['search']['value'];
            $requestedOrder = $reqData['order']['0']['column'] ?? 0;
            $order = TarifaManipuladoLineaModel::SORTABLE[$requestedOrder >= 0 ? $requestedOrder : 0];
            $dir = $reqData['order']['0']['dir'] ?? 'asc';

            $id_TM = $reqData['id_tarifamanipulado'] ?? -1;

            $resourceData = $this->model->getResource("", $id_TM)->orderBy($order, $dir)->limit($length, $start)->get()->getResultObject();

            return $this->respond(Collection::datatable(
                $resourceData,
                $this->model->getResource()->countAllResults(),
                $this->model->getResource($search, $id_TM)->countAllResults()
            ));
        } else {
            return $this->failUnauthorized('Invalid request', 403);
        }
    }

    public function allItemsSelect()
    {
        if ($this->request->isAJAX()) {
            $onlyActiveOnes = true;
            $reqVal = $this->request->getPost('val') ?? 'id';
            $menu = $this->model->getAllForMenu($reqVal . ', tarifa_manipulado_id', 'tarifa_manipulado_id', $onlyActiveOnes, false);
            $nonItem = new \stdClass;
            $nonItem->id = '';
            $nonItem->tarifa_manipulado_id = '- ' . lang('Basic.global.None') . ' -';
            array_unshift($menu, $nonItem);

            $newTokenHash = csrf_hash();
            $csrfTokenName = csrf_token();
            $data = [
                'menu' => $menu,
                $csrfTokenName => $newTokenHash
            ];
            return $this->respond($data);
        } else {
            return $this->failUnauthorized('Invalid request', 403);
        }
    }

    public function menuItems()
    {
        if ($this->request->isAJAX()) {
            $searchStr = goSanitize($this->request->getPost('searchTerm'))[0];
            $reqId = goSanitize($this->request->getPost('id'))[0];
            $reqText = goSanitize($this->request->getPost('text'))[0];
            $onlyActiveOnes = false;
            $columns2select = [$reqId ?? 'id', $reqText ?? 'tarifa_manipulado_id'];
            $onlyActiveOnes = false;
            $menu = $this->model->getSelect2MenuItems($columns2select, $columns2select[1], $onlyActiveOnes, $searchStr);
            $nonItem = new \stdClass;
            $nonItem->id = '';
            $nonItem->text = '- ' . lang('Basic.global.None') . ' -';
            array_unshift($menu, $nonItem);

            $newTokenHash = csrf_hash();
            $csrfTokenName = csrf_token();
            $data = [
                'menu' => $menu,
                $csrfTokenName => $newTokenHash
            ];
            return $this->respond($data);
        } else {
            return $this->failUnauthorized('Invalid request', 403);
        }
    }

}
